

import com.simsilica.lemur.*;
import com.simsilica.lemur.Button.ButtonAction;
import com.simsilica.lemur.component.*;
import com.jme3.texture.Texture.WrapMode;

import march.effect.OpenWindow;
import march.effect.CloseWindow;
import march.effect.ButtonDown;
import march.effect.ButtonUp;

def woodBg = TbtQuadBackgroundComponent.create( 
                                        texture( name:"/Interface/wood-bevel-512x256.jpg", 
                                                 generateMips:false,
                                                 wrap:WrapMode.Clamp ),
                                                 1, 11, 11, 501, 245,
                                                 1f, false );
def woodBg2 = TbtQuadBackgroundComponent.create( 
                                        texture( name:"/Interface/wood-bevel-512x256.jpg", 
                                                 generateMips:false,
                                                 wrap:WrapMode.Clamp ),
                                                 0.5f, 11, 11, 501, 245,
                                                 1f, false );
woodBg2.setMargin(5, 5)                                                 

def paperBg = TbtQuadBackgroundComponent.create( 
                                        texture( name:"/Interface/old-paper.png", 
                                                 generateMips:false,
                                                 wrap:WrapMode.Clamp ),
                                                 1, 30, 30, 482, 482,
                                                 1f, false ); 

def stoneBg = TbtQuadBackgroundComponent.create( 
                                        texture( name:"/Interface/stone-256.jpg", 
                                                 generateMips:false,
                                                 wrap:WrapMode.Clamp ),
                                                 0.75f, 6, 6, 250, 250,
                                                 1f, false );
//stoneBg.setMargin(5, 5)                                                 

def stoneBg2 = TbtQuadBackgroundComponent.create( 
                                        texture( name:"/Interface/stone-256.jpg", 
                                                 generateMips:false,
                                                 wrap:WrapMode.Clamp ),
                                                 0.5f, 6, 6, 250, 250,
                                                 1f, false );
stoneBg2.setMargin(3, 3)                                                 
 
def stoneBevel = TbtQuadBackgroundComponent.create(
                                        texture( name:"/Interface/stone-inner-bevel-128.png", 
                                                 generateMips:false,
                                                 wrap:WrapMode.Clamp ),
                                                 1f, 5, 6, 123, 122,
                                                 1f, false );
stoneBevel.setMargin(4, 5)                                                 
                                                 
def border2 = TbtQuadBackgroundComponent.create(
                                        texture( name:"/com/simsilica/lemur/icons/border.png", 
                                                 generateMips:false,
                                                 wrap:WrapMode.Clamp ),
                                                 1, 2, 2, 6, 6,
                                                 1f, false );
 
def doubleGradient = new QuadBackgroundComponent( color(0.5, 0.75, 0.85, 0.5) );  
doubleGradient.texture = texture( name:"/com/simsilica/lemur/icons/double-gradient-128.png", 
                                  generateMips:false,
                                  wrap:WrapMode.Clamp )


selector( "wood" ) {
    //font = font("Interface/arial-30.fnt")
    font = font("Interface/arial-nopadding-30.fnt")
    fontSize = 30
}

selector( "optionPanel", "wood" ) {
    background = stoneBg.clone()
    background.setColor(color(0.9, 0.7, 0.7, 1))
    background.setMargin(10, 10)
    //background.setColor(color(0.25, 0.5, 0.5, 1))
}

selector( "optionPanel.container", "wood" ) {

    background = woodBg.clone()
    //background.color = color(0.25, 0.4, 0.6, 1)
    background.setMargin(10, 10)
    insets = new Insets3f(2, 2, 2, 2)
} 

selector("optionPanel.title.label", "wood") {
    background = stoneBg.clone()
    background.color = color(0.5, 0.5, 0.5, 0.75)
    background.setMargin(10, 5)
    fontSize = 35     
    color = color(0.45f, 0.5f, 0.5f, 1)
    shadowColor = color(0.7f, 0.75f, 0.75f, 1)
    insets = new Insets3f(0, 0, 3, 0)    
}

selector("main.title.label", "wood") {
    background = woodBg;
    color = color(0.5f, 0.5f, 0.25f, 1)
    shadowColor = color(0.75f, 0.75f, 0.25f, 1)    
    fontSize = 45    
}

selector("mainWindow.container", "wood") {
    background = stoneBg;
    insets = new Insets3f(5, 5, 5, 5)
    
    effects = [
        open:OpenWindow.createCentered(null, 0.5),
        close:new CloseWindow(0.5)
    ]
}

selector("subwindow.container", "wood") {
    background = stoneBevel;
    insets = new Insets3f(5, 0, 5, 0)
}

selector("subwindow.title.label", "wood") {
    background = stoneBg.clone();
    background.color = color(0.5, 0.5, 0.5, 0.75)
    background.setMargin(0, 5)
    fontSize = 35     
    color = color(0.45f, 0.5f, 0.5f, 1)
    shadowColor = color(0.7f, 0.75f, 0.75f, 1)
    insets = new Insets3f(0, 0, 3, 0)    
}

selector("button", "wood") {
    shadowOffset = vec3(2, -2, -1)
    background = stoneBg.clone();    
    insets = new Insets3f(5, 5, 5, 5)
    
    effects = [
        press:new ButtonDown(),
        release:new ButtonUp()
    ]
}

selector("menu.button", "wood") {
    background = new QuadBackgroundComponent(color(0, 0, 0, 0))
    insets = new Insets3f(0, 0, 0, 0)
}

selector("textField", "wood") {
    border = stoneBevel;
}

selector("multiline.textField", "wood") {
    preferredLineCount = 5
}

selector("form.value.label", "wood") {
    textHAlignment = HAlignment.Right
    insets = new Insets3f(5, 5, 5, 5)
}

selector("form.container", "wood") {
    layout = new SpringGridLayout(Axis.Y, Axis.X, FillMode.None, FillMode.Last)
}

selector("button.container", "wood") {
    layout = new SpringGridLayout(Axis.X, Axis.Y, FillMode.Even, FillMode.None)
}

selector("info.label", "wood") {
    fontSize = 20
    border = stoneBevel.clone();
    border.color = color(1, 1, 1, 1)
    background = new QuadBackgroundComponent(color(0.2, 0.3, 0.3, 0.5))
    insets = new Insets3f(5, 5, 5, 5)
}

selector("debug.screen.container", "wood") {
//    background = new QuadBackgroundComponent(color(0.2, 0.3, 0.3, 0.5))
}

selector("debug", "label", "wood") {
    fontSize = 20
}

selector("debug.name.label", "wood") {
    textHAlignment = HAlignment.Right    
}

selector("object.popup.label", "wood") {
    fontSize = 20;
    textHAlignment = HAlignment.Center
    //border = stoneBg2;
    //shadowOffset = vec3(2, -2, -1)
    shadowColor = color(0, 0, 0, 1)
    background = new QuadBackgroundComponent(color(0.2, 0.3, 0.3, 0.5))
    background.setMargin(5, 2)
}

selector("popup.menu.container", "wood") {
    background = woodBg;
    //background.setMargin(5, 2)
}

selector("popup.menu.title", "wood") {
    fontSize = 25;
    background = stoneBg2.clone()
    background.setMargin(10, 5)
    background.color = color(0.6, 0.55, 0.5, 1)
    insets = new Insets3f(0, 0, 2, 0)
}

selector("popup.menu.button", "wood") {
    fontSize = 25;
    insets = new Insets3f(0, 5, 0, 5)
}

selector("dialog", "wood") {
    background = woodBg;
}

selector("dialog.greeting.label", "wood") {
    background = paperBg;
    color = color(0.1, 0.2, 0.4, 1)
}

selector("dialog.option.button", "wood") {
    icon = new IconComponent("Interface/bullet1.png")
    icon.color = color(0.9, 0.9, 0.4, 1)
    background = null;
}

selector("console", "wood") {
    background = border2
}

selector("console.message.list", "wood") {
    fontSize = 20;
}

selector("console.message.list", "button", "wood") {
    fontSize = 20;
}

selector("console.message.label", "wood") {
    fontSize = 20;
}

selector("console.command.textField", "wood") {
    fontSize = 20;
}


selector("window", "wood") {
    background = woodBg2;
}

selector("window.container", "wood") {
    background = null;
}

selector("window.title", "wood") {
    fontSize = 20;
    background = stoneBg2.clone()
    background.setMargin(10, 5)
    background.color = color(0.6, 0.55, 0.5, 1)
    insets = new Insets3f(0, 0, 2, 0)
}


selector("resourceView.container", "wood") {
    background = stoneBg2.clone();
    background.setMargin(10, 10);    
}

selector("resourceView.name.label", "wood") {
    shadowColor = color(0, 0, 0, 0.5)
    shadowOffset = vec3(2, -2, -1)
}

selector("resource.label", "wood") {
    //background = border2;
    shadowColor = color(0, 0, 0, 0.5)
    shadowOffset = vec3(2, -2, -1)
}

selector("delta.label", "wood") {
    //background = border2;
    color = color(0.1, 0.5, 0.8, 1) 
    shadowColor = color(0, 0, 0, 0.5)
    shadowOffset = vec3(2, -2, -1)
}
